{ (c) Ask }
{$APPTYPE CONSOLE}
uses
  SysUtils;

type
  TDir = (dU, dR, dD, dL);
  TDoor = (dNO = 0, dLO = 1, dLI = 2, dRO = 3, dRI = 4);
  TPos = packed record x, y: smallint; d: TDir; end;
var
  i, j, N, qh, qt, x, y: Integer;
  f: TextFile;
  a: array of array of packed record e, s: TDoor; end;
  q: array of TPos;
  w: array of array of array [TDir] of TPos;
  d: TDir;
  p: TPos;

  procedure Enque(nx, ny: Integer; nd: TDir);
  begin
    w[nx, ny, nd] := q[qh];
    q[qt].x := nx; q[qt].y := ny; q[qt].d := nd;
    Inc(qt);
    Assert(qt < High(q));
  end;

begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N);
  SetLength(a, N + 2, N + 2);
  SetLength(w, N + 2, N + 2);
  for i := 1 to N do
    for j := 1 to N do begin
      Read(f, x, y);
      a[j, i].e := TDoor(x); a[j, i].s := TDoor(y);
      FillChar(w[j, i], SizeOf(w[j, i]), 0);
    end;
  CloseFile(f);
  SetLength(q, N * N * 4);
  q[0].x := 1; q[0].y := 1; q[0].d := dR;
  qh := 0; qt := 1;
  while qh < qt do begin
    x := q[qh].x; y := q[qh].y; d := q[qh].d;
    if (x = N) and (y = N) then break;
    if { up }
      (y > 1) and (w[x, y - 1, dU].x = 0) and
      not (a[x, y - 1].s in [dLO, dRO]) and
      not ((d = dR) and (x > 1) and (a[x - 1, y].e = dLO)) and
      not ((d = dL) and (x < N) and (a[x, y].e = dLI))
    then
      Enque(x, y - 1, dU);
    if { down }
      (y < N) and (w[x, y + 1, dD].x = 0) and
      not (a[x, y].s in [dLI, dRI]) and
      not ((d = dR) and (x > 1) and (a[x - 1, y].e = dRO)) and
      not ((d = dL) and (x < N) and (a[x, y].e = dRI))
    then
      Enque(x, y + 1, dD);
    if { left }
      (x > 1) and (w[x - 1, y, dL].x = 0) and
      not (a[x - 1, y].e in [dLO, dRO]) and
      not ((d = dD) and (y > 1) and (a[x, y - 1].s = dRO)) and
      not ((d = dU) and (y < N) and (a[x, y].s = dRI))
    then
      Enque(x - 1, y, dL);
    if { right }
      (x < N) and (w[x + 1, y, dR].x = 0) and
      not (a[x, y].e in [dLI, dRI]) and
      not ((d = dD) and (y > 1) and (a[x, y - 1].s = dLO)) and
      not ((d = dU) and (y < N) and (a[x, y].s = dLI))
    then
      Enque(x + 1, y, dR);
    Inc(qh);
  end;
  AssignFile(f, 'output.txt'); Rewrite(f);
  if qh < qt then begin
    qt := 0;
    p := q[qh];
    while (p.x <> 1) or (p.y <> 1) do begin
      q[qt] := p;
      Inc(qt);
      p := w[p.x, p.y, p.d];
    end;
    Writeln(f, '1 1');
    for i := qt - 1 downto 0 do Writeln(f, q[i].x, ' ', q[i].y);
  end
  else
    Writeln(f, 0);
  CloseFile(f);
end.
